include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext WaitVdp
ext EnemyPattern
ext EnemyRowLeft_
ext GeneratorFlag, NameFlag

dseg
OffPut_@Param0: public OffPut_@Param0
OffPut_vram:
    defw 0
OffPut_@Param1: public OffPut_@Param1
OffPut_c:
    defb 0


pSource equ ZW0
wVram equ ZW1
rShift equ ZB0
lShift equ ZB1
patternOffset equ ZB2
cCount equ ZB3
yCount equ ZB4
patternByte equ ZB5

; void ClearBackgound();
cseg
ClearBackgound_: public ClearBackgound_
    pha
        lda NameFlag
        if eq
            ldy #low Vram_PatternName2 | ldx #high Vram_PatternName2 or $40
        else
            ldy #low Vram_PatternName | ldx #high Vram_PatternName or $40
        endif
        sty <wVram | stx <wVram+1

        ldy #VramHeight
        do
            sei
                lda <wVram | sta VdpWritePort+1
                lda <wVram+1 | sta VdpWritePort+1
                lda #Char_Space
                ldx #WindowWidth
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
            cli
            lda <wVram | clc|adc #VramWidth | sta <wVram
            lda <wVram+1 | adc #0 | sta <wVram+1
            dey
        while ne | wend
    pla
rts


; word OffPut(word vram, byte c);
cseg
OffPut_: public OffPut_
    pha
        ldy OffPut_vram
        lda NameFlag
        if eq
            lda OffPut_vram+1
            ora #$04
            tax
        else
            ldx OffPut_vram+1
        endif
        sei
            sty VdpWritePort+1
            stx VdpWritePort+1
            lda OffPut_c
            sta VdpWritePort
        cli
        lda OffPut_vram | clc|adc #1 | tay
        lda OffPut_vram | adc #0 | tax
    pla
rts


; void SwitchVram();
cseg
SwitchVram_: public SwitchVram_
    pha
        lda NameFlag
        eor #1
        sta NameFlag
        clc|adc #6
        sei
            sta VdpWritePort+1
            lda #$80 or 2 | sta VdpWritePort+1
        cli
    pla
rts


; void UpdateEnemyChars();
PatternGenerator1 equ 4000h+Vram_PatternGenerator+Char_Enemy*CharHeight
PatternGenerator2 equ 4000h+Vram_PatternGenerator2+Char_Enemy*CharHeight
cseg
UpdateEnemyChars_: public UpdateEnemyChars_
    pha
        lda EnemyRowLeft_ | and #7 | sta <rShift
        lda #8 | sec|sbc <rShift | sta <lShift

        lda GeneratorFlag
        if eq
            ldy #low PatternGenerator2 | ldx #high PatternGenerator2
        else
            ldy #low PatternGenerator1 | ldx #high PatternGenerator1
        endif
        sei
            sty VdpWritePort+1 | stx VdpWritePort+1
            lda #0 | sta <patternOffset
            lda #3 | sta <cCount
            do
                ldx <patternOffset
                lda #CharHeight*2 | sta <yCount
                do
                    lda EnemyPattern,x
                    inx | inx
                    ldy <rShift
                    do | while ne
                        lsr a
                        dey
                    wend
                    sta VdpWritePort
                    jsr WaitVdp
                    dec <yCount
                while ne | wend

                ldx <patternOffset
                lda #CharHeight*2 | sta <yCount
                do
                    inx
                    lda EnemyPattern,x
                    inx
                    ldy <lShift
                    do | while ne
                        asl a
                        dey
                    wend
                    sta VdpWritePort
                    jsr WaitVdp
                    dec <yCount
                while ne | wend

                ldx <patternOffset
                lda #CharHeight*2 | sta <yCount
                do
                    lda EnemyPattern,x | inx
                    sta <patternByte
                    lda EnemyPattern,x | inx
                    ldy <rShift
                    do | while ne
                        lsr a | ror <patternByte
                        dey
                    wend
                    lda <patternByte
                    sta VdpWritePort
                    jsr WaitVdp
                    dec <yCount
                while ne | wend

                ldx <patternOffset
                lda #CharHeight*2 | sta <yCount
                do
                    lda EnemyPattern,x | inx
                    sta <patternByte
                    lda EnemyPattern,x | inx
                    ldy <lShift
                    do | while ne
                        asl a | rol <patternByte
                        dey
                    wend
                    lda <patternByte
                    sta VdpWritePort
                    jsr WaitVdp
                    dec <yCount
                while ne | wend

                lda <patternOffset | clc|adc #CharHeight*4 | sta <patternOffset
                dec <cCount
            while ne | wend
        cli            
    pla
rts


; void SwitchChars();
cseg
SwitchChars_: public SwitchChars_
    pha
        lda GeneratorFlag
        eor #1
        sta GeneratorFlag
        sei
            sta VdpWritePort+1
            lda #$80 or 4 | sta VdpWritePort+1
        cli
    pla
rts


; word ForegoundAddress();
cseg
ForegoundAddress_: public ForegoundAddress_
    pha
        lda NameFlag
        if eq
            ldy #low Vram_PatternName | ldx #high Vram_PatternName
        else
            ldy #low Vram_PatternName2 | ldx #high Vram_PatternName2
        endif
    pla
rts


; word BackgoundAddress();
cseg
BackgoundAddress_: public BackgoundAddress_
    pha
        lda NameFlag
        if eq
            ldy #low Vram_PatternName2 | ldx #high Vram_PatternName2
        else
            ldy #low Vram_PatternName | ldx #high Vram_PatternName
        endif
    pla
rts


; void EnemyRowsToVram(word vram, ptr<byte> pSource, byte width);
dseg
EnemyRowsToVram_@Param0: public EnemyRowsToVram_@Param0
EnemyRowsToVram_vram:
    defw 0
EnemyRowsToVram_@Param1: public EnemyRowsToVram_@Param1
EnemyRowsToVram_pSource:
    defw 0
EnemyRowsToVram_@Param2: public EnemyRowsToVram_@Param2
EnemyRowsToVram_width:
    defb 0
cseg
EnemyRowsToVram_: public EnemyRowsToVram_
    pha
        lda EnemyRowsToVram_pSource | sta <pSource
        lda EnemyRowsToVram_pSource+1 | sta <pSource+1

        ldy EnemyRowsToVram_vram
        ldx EnemyRowsToVram_vram+1
        lda NameFlag
        if eq
            inx | inx | inx | inx
        endif
        sty <wVram | stx <wVram+1

        lda #2 | sta <yCount
        do
            sei
                lda <wVram | sta VdpWritePort+1
                lda <wVram+1 | ora #$40 | sta VdpWritePort+1
                ldy #0
                ldx EnemyRowsToVram_width
                do
                    lda (<pSource),y | iny
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
            cli
            lda <pSource | clc|adc #12*2+1 | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <wVram | clc|adc #VramWidth | sta <wVram
            lda <wVram+1 | adc #0 | sta <wVram+1

            dec <yCount
        while ne | wend
    pla
rts